-- MasterMerchant Long running operation utility functions 
-- Last Updated April, 2015 by Chris Lasswell (@Philgo68) - Philgo68@gmail.com
-- Released under terms in license accompanying this file.
-- Distribution without license is prohibited!

LongRunningOperations = {}
LongRunningOperations.Queue = {}
LongRunningOperations.Paused = false

function LongRunningOperations:Add(func, name)
  table.insert(self.Queue, 1, {func, name})  
end

function LongRunningOperations:ContinueWith(func, name)
  table.insert(self.Queue, {func, name})  
end

function LongRunningOperations:Start()
  self.Paused = false
  self:Next()
end

function LongRunningOperations:Next() 
  if not self.Paused then
    local nextFunc = table.remove(self.Queue)
    if nextFunc then
      
      --DEBUG
      --local start = GetTimeStamp()
      
      nextFunc[1]()

      --DEBUG
      --d((nextFunc[2] or 'Unnamed function') .. ': ' .. GetTimeStamp() - start)
      
      zo_callLater(function() self:Next() end, 20) 
    end
  end
end

function LongRunningOperations:Pause()
  self.Paused = true
end
